#!/usr/bin/perl
# Show a form for selecting if this system is a master or slave

require './server-manager-lib.pl';
&can_action_error(undef, "global");
&ui_print_header(undef, $text{'repl_title'}, "", 0, 0, "repl");

# Work out current mode
@servers = &list_available_managed_servers_sorted();
$mode = &get_replication_mode();
$master = &get_replication_master();
@replicas = &list_replica_servers();

print $text{'repl_desc'},"<p>\n";
print &ui_form_start("save_repl.cgi", "post");
print &ui_table_start(undef, undef, 2);

# Show mode selector
print &ui_table_row(undef,
    &ui_radio_table("mode", $mode,
	[ [ 0, $text{'repl_mode0'} ],
	  [ 1, $text{'repl_mode1'},
		$master ? &text('repl_master', $master)
			: $text{'repl_nomaster'} ],
	  [ 2, $text{'repl_mode2'},
		&ui_multi_select("servers",
		   [ map { [ $_->{'id'}, $_->{'host'} ] } @replicas ],
		   [ map { [ $_->{'id'}, $_->{'host'} ] } @servers ],
		   10, 1, 0, $text{'repl_opts'}, $text{'repl_vals'}).
		&ui_checkbox("now", 1, $text{'repl_now'}, 1) ],
	]));

print &ui_table_end();
print &ui_form_end([ [ undef, $text{'save'} ] ]);

&ui_print_footer("", $text{'index_return'});

