#!/usr/bin/perl
# Set up this system as a replication master, slave or neither

require './server-manager-lib.pl';
&error_setup($text{'repl_err'});
&can_action_error(undef, "global");
&ReadParse();

if ($in{'mode'} == 0) {
	# Stand-alone system
	&save_replication_mode(0);
	&save_replication_master();
	}
elsif ($in{'mode'} == 1) {
	# Replica
	&save_replication_mode(1);
	}
else {
	# Master of other slaves .. make sure they are valid
	@ids = split(/\r?\n/, $in{'servers'});
	@ids || &error($text{'repl_enone'});
	@replicas = ( );
	foreach $id (@ids) {
		$s = &get_managed_server($id);
		$s || &error(&text('repl_eid', $id));
		$s->{'status'} eq 'virt' || $s->{'status'} eq 'novirt' ||
			&error(&text('repl_ewebmin', $s->{'host'}));
		$last_remote_error = undef;
		$sconfig = &remote_foreign_require($s, "server-manager");
		$last_remote_error &&
			&error(&text('repl_eremote', $s->{'host'},
				     $last_remote_error));
		$isrepl = &remote_foreign_call($s, "server-manager",
					     "is_cloudmin_replica");
		$isrepl eq '1' || &error(&text('repl_ereplica', $s->{'host'}));
		push(@replicas, $s);
		}
	&save_replication_mode(2);
	&save_replication_master();
	&save_replica_servers(\@replicas);
	}

&webmin_log("repl");

if ($in{'mode'} == 2 && $in{'now'}) {
	# Perform one replication run, and tell the user
	&ui_print_header(undef, $text{'repl_title'}, "");

	print $text{'repl_doing'},"<p>\n";
	foreach $rv (&replicate_to_servers()) {
		print $rv->{'replica'}->{'host'}," :\n";
		if (!$rv->{'ok'}) {
			print "<font color=#ff0000>$rv->{'err'}</font>\n";
			}
		else {
			print &text('repl_ok', scalar(@{$rv->{'servers'}}));
			}
		print "<br>\n";
		}

	&ui_print_footer("", $text{'index_return'});
	}
else {
	&redirect("");
	}

